/*
 * Copyright 2015-2017 Filippo Leonardi <filippo.leonardi@sam.math.ethz.ch>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

#pragma once

//! \file JobInfo.hpp Contains the definition of JobInfo and extra related types.

//
// Created by filippo on 11/12/17.
//

#include <mpi.h>

#include "utilities/debug.hpp"

namespace dafuq::base {

//! \enum IntraLevelType
//! Type of data stored for the level.
enum class IntraLevelType : int {
    //!< No data (invalid)
            None = 0,
    //! Only coarsest solution
            Low = 1 << 0,
    //! Only finest solution
            High = 1 << 1,
    //! Both coarse and fine solution
            All = Low | High,
};

//! \brief Contains information for the Job about the Aggregate the Solver creates.
//!
//! This data is stored in a POD for easy and fast MPI transfer.
//!
//! This class will inform the Aggregator on how to process an Aggregate.
struct AggregateInfo {
    //! Level from which the Aggregate comes (for multi-level approaches).
    int level;
    //! Type of data the Aggregate represents.
    IntraLevelType intra_level_type;
    //! Represents the batch size of a single Solver (how many solutions will be aggregated)
    int batch_size;
    //! Simulation id attached to the Job.
    int sim_id;
};

//! \class A lightweight structure containing information about the Job.
//!
//! Useful for streamlined communication across ranks.
//!
//! This class is registered via MPI and send using a custom datatype.
class JobInfo {
public:
    //! \brief Register 'JobInfo' as datatype for MPI.
    //!
    //! Should be called only once, and before any use of mpi_type. It is safe also to call multiple times.
    //!
    //! \return The data type generated by MPI.
    static MPI_Datatype register_mpi_type();

    //! \brief Obtain the data-type associated with this class.
    //!
    //! If type is not registered, we do it.
    //!
    //! \return The MPI_Datatype of this class.
    static MPI_Datatype get() {
        if( !registered ) {
            debug::log_warning(mpi::world,
                               "MPI Type for 'JobInfo' was not "
                                       "registered, registering type!");
            register_mpi_type();
        }

        return mpi_type;
    }

    //! \brief Returns true if the type has been registered with MPI.
    //!
    //! \return Return true if mpi_type is valid.
    static bool is_registered() {
        return registered;
    }

    //! \brief Check whether the Job id matches that of a termination Job.
    //!
    //! \return True if the Job is indeed a termination Job.
    bool is_termination_job() {
        return id == termination_id;
    }

    //! Id of the Job.
    int id;
    //! Number of ranks assigned to the Job.
    int num_ranks;
    //! Extra information about the Aggregate created by the Job.
    AggregateInfo aggregate_info;

    //! Id for termination Job.
    static constexpr int termination_id = -1;
private:
    //! Static container checking whether the data is registered.
    static bool registered;
    //! The MPI_Datatype on which the class is registered.
    static MPI_Datatype mpi_type;
};

} // END namespace dafuq::base